Index: meson/arch/ia64/meson.build
===================================================================
--- meson/arch/ia64/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ meson/arch/ia64/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -36,4 +36,7 @@
 arch_boot_c_args = [ '-D__LE__', '-fno-unwind-tables', '-mfixed-range=f32-f127', '-mno-pic', '-mno-sdata' ]
 
+# work around GCC bug 112604
+arch_uspace_c_args += ['-fno-unswitch-loops']
+
 arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
 arch_kernel_link_args = [ '-nostdlib', '-Wl,-EL', '-Wl,--no-warn-rwx-segments']
Index: uspace/app/corecfg/meson.build
===================================================================
--- uspace/app/corecfg/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/corecfg/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2013 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'corecfg' ]
 src = files('corecfg.c')
Index: uspace/app/hbench/meson.build
===================================================================
--- uspace/app/hbench/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/hbench/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2018 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'math' ]
+deps = [ 'math', 'ipctest' ]
 src = files(
 	'benchlist.c',
Index: uspace/app/mkbd/meson.build
===================================================================
--- uspace/app/mkbd/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/mkbd/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'usb', 'usbdev', 'usbhid', 'drv' ]
+deps = [ 'usb', 'usbdev', 'usbhid', 'drv', 'console' ]
 src = files('main.c')
Index: uspace/app/modplay/meson.build
===================================================================
--- uspace/app/modplay/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/modplay/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'trackmod', 'hound', 'pcm' ]
+deps = [ 'trackmod', 'hound', 'pcm', 'console' ]
 src = files('modplay.c')
 
Index: uspace/app/netecho/meson.build
===================================================================
--- uspace/app/netecho/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/netecho/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('comm.c', 'netecho.c')
Index: uspace/app/nterm/meson.build
===================================================================
--- uspace/app/nterm/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/nterm/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('conn.c', 'nterm.c')
Index: uspace/app/ping/meson.build
===================================================================
--- uspace/app/ping/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/ping/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('ping.c')
Index: uspace/app/taskbar-cfg/smeedit.c
===================================================================
--- uspace/app/taskbar-cfg/smeedit.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/taskbar-cfg/smeedit.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -41,4 +41,5 @@
 #include "taskbar-cfg.h"
 #include "smeedit.h"
+#include "startmenu.h"
 
 static void wnd_close(ui_window_t *, void *);
@@ -111,4 +112,5 @@
 	}
 
+	smee->startmenu = smenu;
 	smee->smentry = smentry;
 
@@ -361,5 +363,5 @@
 
 	(void)smenu_entry_save(smee->smentry->entry);
-
+	startmenu_entry_update(smee->smentry);
 	smeedit_destroy(smee);
 }
Index: uspace/app/taskbar-cfg/startmenu.c
===================================================================
--- uspace/app/taskbar-cfg/startmenu.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/taskbar-cfg/startmenu.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -349,6 +349,4 @@
 	smentry->entry = entry;
 
-	printf("startmenu_insert: smentry=%p entry=%p\n",
-	    smentry, entry);
 	ui_list_entry_attr_init(&attr);
 	attr.caption = smenu_entry_get_caption(entry);
@@ -390,5 +388,4 @@
 	smentry = startmenu_get_selected(smenu);
 
-	printf("smeedit_create:entry=%p\n", smentry);
 	rc = smeedit_create(smenu, smentry, &smee);
 	if (rc != EOK)
@@ -398,4 +395,17 @@
 }
 
+/** Update start menu entry caption.
+ *
+ * When editing an entry the entry's label might change. We need
+ * to update the list entry caption to reflect that.
+ *
+ * @param entry Start menu entry
+ */
+errno_t startmenu_entry_update(startmenu_entry_t *entry)
+{
+	return ui_list_entry_set_caption(entry->lentry,
+	    smenu_entry_get_caption(entry->entry));
+}
+
 /** Entry in entry list is selected.
  *
Index: uspace/app/taskbar-cfg/startmenu.h
===================================================================
--- uspace/app/taskbar-cfg/startmenu.h	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/taskbar-cfg/startmenu.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -48,4 +48,5 @@
 extern startmenu_entry_t *startmenu_get_selected(startmenu_t *);
 extern void startmenu_edit(startmenu_t *);
+extern errno_t startmenu_entry_update(startmenu_entry_t *);
 
 #endif
Index: uspace/app/tester/meson.build
===================================================================
--- uspace/app/tester/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/tester/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -29,5 +29,5 @@
 #
 
-deps = [ 'block', 'codepage', 'drv', 'math' ]
+deps = [ 'block', 'codepage', 'drv', 'math', 'ipctest', 'console' ]
 src = files(
 	'tester.c',
Index: uspace/app/tetris/meson.build
===================================================================
--- uspace/app/tetris/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/tetris/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'shapes.c',
Index: uspace/app/top/meson.build
===================================================================
--- uspace/app/top/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/top/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'top.c',
Index: uspace/app/trace/meson.build
===================================================================
--- uspace/app/trace/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/trace/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'trace.c',
Index: uspace/app/uidemo/uidemo.c
===================================================================
--- uspace/app/uidemo/uidemo.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/app/uidemo/uidemo.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -288,5 +288,5 @@
 	pos = ui_scrollbar_get_pos(scrollbar);
 	ui_scrollbar_set_pos(scrollbar, pos -
-	    ui_scrollbar_through_length(scrollbar) / 4);
+	    ui_scrollbar_trough_length(scrollbar) / 4);
 
 	pos = ui_scrollbar_get_pos(scrollbar);
@@ -305,5 +305,5 @@
 	pos = ui_scrollbar_get_pos(scrollbar);
 	ui_scrollbar_set_pos(scrollbar, pos +
-	    ui_scrollbar_through_length(scrollbar) / 4);
+	    ui_scrollbar_trough_length(scrollbar) / 4);
 
 	pos = ui_scrollbar_get_pos(scrollbar);
@@ -1270,5 +1270,5 @@
 
 	ui_scrollbar_set_thumb_length(demo.hscrollbar,
-	    ui_scrollbar_through_length(demo.hscrollbar) / 4);
+	    ui_scrollbar_trough_length(demo.hscrollbar) / 4);
 
 	rc = ui_fixed_add(demo.bfixed, ui_scrollbar_ctl(demo.hscrollbar));
@@ -1302,5 +1302,5 @@
 
 	ui_scrollbar_set_thumb_length(demo.vscrollbar,
-	    ui_scrollbar_through_length(demo.vscrollbar) / 4);
+	    ui_scrollbar_trough_length(demo.vscrollbar) / 4);
 
 	rc = ui_fixed_add(demo.bfixed, ui_scrollbar_ctl(demo.vscrollbar));
Index: uspace/drv/hid/adb-kbd/adb-kbd.c
===================================================================
--- uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -34,5 +34,5 @@
 #include <ddf/log.h>
 #include <errno.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <ipc/adb.h>
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/adb-kbd/ctl.c
===================================================================
--- uspace/drv/hid/adb-kbd/ctl.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/adb-kbd/ctl.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -33,5 +33,5 @@
 
 #include <errno.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
 
Index: uspace/drv/hid/adb-kbd/meson.build
===================================================================
--- uspace/drv/hid/adb-kbd/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/adb-kbd/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,4 +27,5 @@
 #
 
+deps = [ 'input' ]
 src = files(
 	'main.c',
Index: uspace/drv/hid/adb-mouse/meson.build
===================================================================
--- uspace/drv/hid/adb-mouse/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/adb-mouse/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'adb-mouse.c')
Index: uspace/drv/hid/atkbd/atkbd.c
===================================================================
--- uspace/drv/hid/atkbd/atkbd.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/atkbd/atkbd.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -38,7 +38,7 @@
 #include <errno.h>
 #include <ddf/log.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
 #include <ipc/kbdev.h>
 #include <abi/ipc/methods.h>
Index: uspace/drv/hid/atkbd/meson.build
===================================================================
--- uspace/drv/hid/atkbd/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/atkbd/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'atkbd.c')
Index: uspace/drv/hid/ps2mouse/meson.build
===================================================================
--- uspace/drv/hid/ps2mouse/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/ps2mouse/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'ps2mouse.c')
Index: uspace/drv/hid/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/hid/ps2mouse/ps2mouse.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/ps2mouse/ps2mouse.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -40,5 +40,4 @@
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
 #include <ipc/mouseev.h>
 #include <abi/ipc/methods.h>
Index: uspace/drv/hid/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -41,5 +41,5 @@
 
 #include <io/keycode.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <abi/ipc/methods.h>
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/usbhid/kbd/kbdrepeat.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -36,6 +36,6 @@
 
 #include <fibril_synch.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
-#include <io/console.h>
 #include <errno.h>
 
Index: uspace/drv/hid/usbhid/meson.build
===================================================================
--- uspace/drv/hid/usbhid/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/usbhid/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'usbhid', 'usbdev', 'usb' ]
+deps = [ 'usbhid', 'usbdev', 'usb', 'input' ]
 includes += [ include_directories('.') ]
 src = files(
Index: uspace/drv/hid/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -46,5 +46,4 @@
 #include <str_error.h>
 #include <ipc/mouseev.h>
-#include <io/console.h>
 
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/usbhid/multimedia/multimedia.c
===================================================================
--- uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -51,5 +51,5 @@
 
 #include <ipc/kbdev.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 
 #define NAME  "multimedia-keys"
Index: uspace/drv/hid/xtkbd/meson.build
===================================================================
--- uspace/drv/hid/xtkbd/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/xtkbd/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'xtkbd.c')
Index: uspace/drv/hid/xtkbd/xtkbd.c
===================================================================
--- uspace/drv/hid/xtkbd/xtkbd.c	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/drv/hid/xtkbd/xtkbd.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -39,5 +39,5 @@
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <ipc/kbdev.h>
 #include <abi/ipc/methods.h>
Index: uspace/lib/c/generic/adt/prodcons.c
===================================================================
--- uspace/lib/c/generic/adt/prodcons.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/c/generic/adt/prodcons.c	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,72 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <adt/prodcons.h>
+#include <adt/list.h>
+#include <fibril_synch.h>
+
+void prodcons_initialize(prodcons_t *pc)
+{
+	list_initialize(&pc->list);
+	fibril_mutex_initialize(&pc->mtx);
+	fibril_condvar_initialize(&pc->cv);
+}
+
+void prodcons_produce(prodcons_t *pc, link_t *item)
+{
+	fibril_mutex_lock(&pc->mtx);
+
+	list_append(item, &pc->list);
+	fibril_condvar_signal(&pc->cv);
+
+	fibril_mutex_unlock(&pc->mtx);
+}
+
+link_t *prodcons_consume(prodcons_t *pc)
+{
+	fibril_mutex_lock(&pc->mtx);
+
+	while (list_empty(&pc->list))
+		fibril_condvar_wait(&pc->cv, &pc->mtx);
+
+	link_t *head = list_first(&pc->list);
+	list_remove(head);
+
+	fibril_mutex_unlock(&pc->mtx);
+
+	return head;
+}
+
+/** @}
+ */
Index: uspace/lib/c/include/adt/prodcons.h
===================================================================
--- uspace/lib/c/include/adt/prodcons.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/c/include/adt/prodcons.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBC_PRODCONS_H_
+#define _LIBC_PRODCONS_H_
+
+#include <adt/list.h>
+#include <fibril_synch.h>
+
+typedef struct {
+	fibril_mutex_t mtx;
+	fibril_condvar_t cv;
+	list_t list;
+} prodcons_t;
+
+extern void prodcons_initialize(prodcons_t *);
+extern void prodcons_produce(prodcons_t *, link_t *);
+extern link_t *prodcons_consume(prodcons_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/meson.build
===================================================================
--- uspace/lib/c/meson.build	(revision 56a3c29e88b204aab857b6e159ccf9e553cf0c09)
+++ uspace/lib/c/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -49,7 +49,4 @@
 allow_shared = true
 
-# FIXME: symlinks from uspace to kernel will break in future Meson version
-#        we should instead move the duplicated library parts into a shared location.
-
 uspace_lib_devel_install_script_text += 'mkdir -p "${DESTDIR}include/libc"'
 foreach idir : incdirs
@@ -66,5 +63,4 @@
 	'common/adt/hash_table.c',
 	'common/adt/odict.c',
-	'common/adt/prodcons.c',
 	'common/printf/printf_core.c',
 	'common/stdc/ctype.c',
@@ -79,12 +75,11 @@
 
 	'generic/libc.c',
+	'generic/adt/prodcons.c',
 	'generic/as.c',
 	'generic/ddi.c',
 	'generic/perm.c',
 	'generic/capa.c',
-	'generic/clipboard.c',
 	'generic/config.c',
 	'generic/context.c',
-	'generic/corecfg.c',
 	'generic/device/clock_dev.c',
 	'generic/device/hw_res.c',
@@ -99,5 +94,4 @@
 	'generic/errno.c',
 	'generic/inttypes.c',
-	'generic/ipc_test.c',
 	'generic/loc.c',
 	'generic/string.c',
@@ -109,8 +103,5 @@
 	'generic/imath.c',
 	'generic/io/asprintf.c',
-	'generic/io/input.c',
 	'generic/io/io.c',
-	'generic/io/chargrid.c',
-	'generic/io/output.c',
 	'generic/io/printf.c',
 	'generic/io/log.c',
@@ -121,6 +112,4 @@
 	'generic/io/vprintf.c',
 	'generic/io/vsnprintf.c',
-	'generic/io/con_srv.c',
-	'generic/io/console.c',
 	'generic/io/table.c',
 	'generic/irq.c',
Index: uspace/lib/clipboard/doc/doxygroups.h
===================================================================
--- uspace/lib/clipboard/doc/doxygroups.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/clipboard/doc/doxygroups.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,3 @@
+/** @addtogroup libclipboard libclipboard
+ * @ingroup libs
+ */
Index: uspace/lib/clipboard/include/clipboard.h
===================================================================
--- uspace/lib/clipboard/include/clipboard.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/clipboard/include/clipboard.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libclipboard
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBCLIPBOARD_CLIPBOARD_H_
+#define _LIBCLIPBOARD_CLIPBOARD_H_
+
+#include <errno.h>
+
+extern errno_t clipboard_put_str(const char *);
+extern errno_t clipboard_get_str(char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/clipboard/include/ipc/clipboard.h
===================================================================
--- uspace/lib/clipboard/include/ipc/clipboard.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/clipboard/include/ipc/clipboard.h	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2009 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libcipc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBCLIPBOARD_IPC_CLIPBOARD_H_
+#define _LIBCLIPBOARD_IPC_CLIPBOARD_H_
+
+#include <ipc/common.h>
+
+typedef enum {
+	CLIPBOARD_PUT_DATA = IPC_FIRST_USER_METHOD,
+	CLIPBOARD_GET_DATA,
+	CLIPBOARD_CONTENT
+} clipboard_request_t;
+
+typedef enum {
+	CLIPBOARD_TAG_NONE,
+	CLIPBOARD_TAG_DATA
+} clipboard_tag_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/clipboard/meson.build
===================================================================
--- uspace/lib/clipboard/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
+++ uspace/lib/clipboard/meson.build	(revision 4f6368c9f43c5e184ce86a446688b4311b0d63f1)
@@ -0,0 +1,29 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+src = files('src/clipboard.c')
